from snesedit.codecs import pad
from snesedit.fields import SimpleField

NAMES = ["Terra", "Locke", "Cyan", "Shadow", "Edgar", "Sabin", "Celes", "Strago",
         "Relm", "Setzer", "Mog", "Gau", "Gogo", "Umaro", "Wedge", "Vicks"]

ITEMS = {
    0x00: 'Dirk',
    0x01: 'MithrilKnife',
    0x02: 'Guardian',
    0x03: 'Air Lancet',
    0x04: 'ThiefKnife',
    0x05: 'Assassin',
    0x06: 'Man Eater',
    0x07: 'SwordBreaker',
    0x08: 'Graedus',
    0x09: 'ValiantKnife',
    0x0A: 'MithrilBlade',
    0x0B: 'RegalCutlass',
    0x0C: 'Rune Edge',
    0x0D: 'Flame Sabre',
    0x0E: 'Blizzard',
    0x0F: 'ThunderBlade',
    0x10: 'Epee',
    0x11: 'Break Blade',
    0x12: 'Drainer',
    0x13: 'Enhancer',
    0x14: 'Crystal',
    0x15: 'Falchion',
    0x16: 'Soul Sabre',
    0x17: 'Ogre Nix',
    0x18: 'Excalibur',
    0x19: 'Scimitar',
    0x1A: 'Illumina',
    0x1B: 'Ragnarok',
    0x1C: 'Atma Weapon',
    0x1D: 'Mithril Pike',
    0x1E: 'Trident',
    0x1F: 'Stout Spear',
    0x20: 'Partisan',
    0x21: 'Pearl Lance',
    0x22: 'Gold Lance',
    0x23: 'Aura Lance',
    0x24: 'Imp Halberd',
    0x25: 'Imperial',
    0x26: 'Kodachi',
    0x27: 'Blossom',
    0x28: 'Hardened',
    0x29: 'Striker',
    0x2A: 'Stunner',
    0x2B: 'Ashura',
    0x2C: 'Kotetsu',
    0x2D: 'Forged',
    0x2E: 'Tempest',
    0x2F: 'Murasame',
    0x30: 'Aura',
    0x31: 'Strato',
    0x32: 'Sky Render',
    0x33: 'Heal Rod',
    0x34: 'Mithril Rod',
    0x35: 'Fire Rod',
    0x36: 'Ice Rod',
    0x37: 'Thunder Rod',
    0x38: 'Poison Rod',
    0x39: 'Pearl Rod',
    0x3A: 'Gravity Rod',
    0x3B: 'Punisher',
    0x3C: 'Magus Rod',
    0x3D: 'Chocobo Brsh',
    0x3E: 'DaVinci Brsh',
    0x3F: 'Magical Brsh',
    0x40: 'Rainbow Brsh',
    0x41: 'Shuriken',
    0x42: 'Ninja Star',
    0x43: 'Tack Star',
    0x44: 'Flail',
    0x45: 'Full Moon',
    0x46: 'Morning Star',
    0x47: 'Boomerang',
    0x48: 'Rising Sun',
    0x49: 'Hawk Eye',
    0x4A: 'Bone Club',
    0x4B: 'Sniper',
    0x4C: 'Wing Edge',
    0x4D: 'Cards',
    0x4E: 'Darts',
    0x4F: 'Doom Darts',
    0x50: 'Trump',
    0x51: 'Dice',
    0x52: 'Fixed Dice',
    0x53: 'MetalKnuckle',
    0x54: 'Mithril Claw',
    0x55: 'Kaiser',
    0x56: 'Poison Claw',
    0x57: 'Fire Knuckle',
    0x58: 'Dragon Claw',
    0x59: 'Tiger Fangs',
    0x5A: 'Buckler',
    0x5B: 'Heavy Shld',
    0x5C: 'Mithril Shld',
    0x5D: 'Gold Shld',
    0x5E: 'Aegis Shld',
    0x5F: 'Diamond Shld',
    0x60: 'Flame Shld',
    0x61: 'Ice Shld',
    0x62: 'Thunder Shld',
    0x63: 'Crystal Shld',
    0x64: 'Genji Shld',
    0x65: 'TortoiseShld',
    0x66: 'Cursed Shld',
    0x67: 'Paladin Shld',
    0x68: 'Force Shield',
    0x69: 'Leather Hat',
    0x6A: 'Hair Band',
    0x6B: 'Plumed Hat',
    0x6C: 'Beret',
    0x6D: 'Magus Hat',
    0x6E: 'Bandana',
    0x6F: 'Iron Helmet',
    0x70: 'Coronet',
    0x71: 'Bard\'s Hat',
    0x72: 'Green Beret',
    0x73: 'Heaad Band',
    0x74: 'Mithril Helm',
    0x75: 'Tiara',
    0x76: 'Gold Helmet',
    0x77: 'Tiger Mask',
    0x78: 'Red Cap',
    0x79: 'Mystery Veil',
    0x7A: 'Circlet',
    0x7B: 'Regal Crown',
    0x7C: 'Diamond Helm',
    0x7D: 'Dark Hood',
    0x7E: 'Crystal Helm',
    0x7F: 'Oath Veil',
    0x80: 'Cat Hood',
    0x81: 'Genji Helmet',
    0x82: 'Thornlet',
    0x83: 'Titanium',
    0x84: 'LeatherArmor',
    0x85: 'Cotton Robe',
    0x86: 'Kung Fu Suit',
    0x87: 'Iron Armor',
    0x88: 'Silk Robe',
    0x89: 'Mithril Vest',
    0x8A: 'Ninja Gear',
    0x8B: 'White Dress',
    0x8C: 'Mithril Mail',
    0x8D: 'Gaia Gear',
    0x8E: 'Mirage Vest',
    0x8F: 'Gold Armor',
    0x90: 'Power Sash',
    0x91: 'Light Robe',
    0x92: 'Diamond Vest',
    0x93: 'Red Jacket',
    0x94: 'Force Armor',
    0x95: 'DiamondArmor',
    0x96: 'Dark Gear',
    0x97: 'Tao Robe',
    0x98: 'Crystal Mail',
    0x99: 'Czarina Gown',
    0x9A: 'Genji Armor',
    0x9B: 'Imp\'s Armor',
    0x9C: 'Minerva',
    0x9D: 'Tabby Suit',
    0x9E: 'Chocobo Suit',
    0x9F: 'Moogle Suit',
    0xA0: 'Nutkin Suit',
    0xA1: 'BehemothSuit',
    0xA2: 'Snow Muffler',
    0xA3: 'NoiseBlaster',
    0xA4: 'Bio Blaster',
    0xA5: 'Flash',
    0xA6: 'Chain Saw',
    0xA7: 'Debilitator',
    0xA8: 'Drill',
    0xA9: 'Air Anchor',
    0xAA: 'AutoCrossbow',
    0xAB: 'Fire Skean',
    0xAC: 'Water Edge',
    0xAD: 'Bolt Edge',
    0xAE: 'Inviz Edge',
    0xAF: 'Shadow Edge',
    0xB0: 'Goggles',
    0xB1: 'Star Pendant',
    0xB2: 'Peace Ring',
    0xB3: 'Amulet',
    0xB4: 'White Cape',
    0xB5: 'Jewel Ring',
    0xB6: 'Fairy Ring',
    0xB7: 'Barrier Ring',
    0xB8: 'MithrilGlove',
    0xB9: 'Guard Ring',
    0xBA: 'RunningShoes',
    0xBB: 'Wall Ring',
    0xBC: 'Cherub Down',
    0xBD: 'Cure Ring',
    0xBE: 'True Knight',
    0xBF: 'DragoonBoots',
    0xC0: 'Zephyr Cape',
    0xC1: 'Czarina Ring',
    0xC2: 'Cursed Ring',
    0xC3: 'Earrings',
    0xC4: 'Atlas Armlet',
    0xC5: 'Blizzard Orb',
    0xC6: 'Rage Ring',
    0xC7: 'Sneak Ring',
    0xC8: 'Pod Bracelet',
    0xC9: 'Hero Ring',
    0xCA: 'Ribbon',
    0xCB: 'Muscle Belt',
    0xCC: 'Crystal Orb',
    0xCD: 'Gold Hairpin',
    0xCE: 'Economizer',
    0xCF: 'Thief Glove',
    0xD0: 'Gauntlet',
    0xD1: 'Genji Glove',
    0xD2: 'Hyper Wrist',
    0xD3: 'Offering',
    0xD4: 'Beads',
    0xD5: 'Black Belt',
    0xD6: 'Coin Toss',
    0xD7: 'FakeMustache',
    0xD8: 'Gem Box',
    0xD9: 'Dragon Horn',
    0xDA: 'Merit Award',
    0xDB: 'Memento Ring',
    0xDC: 'Safety Bit',
    0xDD: 'Relic Ring',
    0xDE: 'Moogle Charm',
    0xDF: 'Charm Bangle',
    0xE0: 'Marvel Shoes',
    0xE1: 'Back Guard',
    0xE2: 'Gale Hairpin',
    0xE3: 'Sniper Sight',
    0xE4: 'Exp. Egg',
    0xE5: 'Tintinabar',
    0xE6: 'Sprint Shoes',
    0xE7: 'Rename Card',
    0xE8: 'Tonic',
    0xE9: 'Potion',
    0xEA: 'X-Potion',
    0xEB: 'Tincture',
    0xEC: 'Ether',
    0xED: 'X-Ether',
    0xEE: 'Elixer',
    0xEF: 'Megalixer',
    0xF0: 'Fenix Down',
    0xF1: 'Revivify',
    0xF2: 'Antidote',
    0xF3: 'Eyedrop',
    0xF4: 'Soft',
    0xF5: 'Remedy',
    0xF6: 'Sleeping Bag',
    0xF7: 'Tent',
    0xF8: 'Green Cherry',
    0xF9: 'Magicite',
    0xFA: 'Super Ball',
    0xFB: 'Echo Screen',
    0xFC: 'Smoke Bomb',
    0xFD: 'Warp Stone',
    0xFE: 'Dried Meat',
    0xFF: 'Nothing',
}

ITEM_IDS = {name: _id for _id, name in ITEMS.items()}

assert len(ITEM_IDS) == len(ITEMS)

RARE_ITEMS = [
    'Cider', 'Old Clock-Key', 'Fish (A yummy fish)', 'Fish (Just a fish)', 'Fish (A rotten fish)',
    'Fish (Fish)', 'Lump of Metal', "Lola's Letter", 'Coral', 'Books', 'Royal Letter', 'Rust-Rid',
    'Autograph', 'Manicure', 'Opera Record', 'Magn. Glass', 'Eerie Stone', 'Odd Picture',
    'Dull Picture', 'Pendant'
]

CHARACTER_DECODING = {
    0x7F: ' ',
    0x80: 'A',
    0x81: 'B',
    0x82: 'C',
    0x83: 'D',
    0x84: 'E',
    0x85: 'F',
    0x86: 'G',
    0x87: 'H',
    0x88: 'I',
    0x89: 'J',
    0x8A: 'K',
    0x8B: 'L',
    0x8C: 'M',
    0x8D: 'N',
    0x8E: 'O',
    0x8F: 'P',
    0x90: 'Q',
    0x91: 'R',
    0x92: 'S',
    0x93: 'T',
    0x94: 'U',
    0x95: 'V',
    0x96: 'W',
    0x97: 'X',
    0x98: 'Y',
    0x99: 'Z',
    0x9A: 'a',
    0x9B: 'b',
    0x9C: 'c',
    0x9D: 'd',
    0x9E: 'e',
    0x9F: 'f',
    0xA0: 'g',
    0xA1: 'h',
    0xA2: 'i',
    0xA3: 'j',
    0xA4: 'k',
    0xA5: 'l',
    0xA6: 'm',
    0xA7: 'n',
    0xA8: 'o',
    0xA9: 'p',
    0xAA: 'q',
    0xAB: 'r',
    0xAC: 's',
    0xAD: 't',
    0xAE: 'u',
    0xAF: 'v',
    0xB0: 'w',
    0xB1: 'x',
    0xB2: 'y',
    0xB3: 'z',
    0xB4: '0',
    0xB5: '1',
    0xB6: '2',
    0xB7: '3',
    0xB8: '4',
    0xB9: '5',
    0xBA: '6',
    0xBB: '7',
    0xBC: '8',
    0xBD: '9',
    0xBE: '!',
    0xBF: '?',
    0xC0: '/',
    0xC1: ':',
    0xC2: '"',
    0xC3: "'",
    0xC4: '-',
    0xC5: '.',
}

CHARACTER_ENCODING = {c: b for b, c in CHARACTER_DECODING.items()}


class FF3String(SimpleField[str]):

    def __init__(self, offset):
        super(FF3String, self).__init__(offset, size=6)

    def decode_from_bytes(self, source: bytes) -> str:
        return ''.join([CHARACTER_DECODING.get(b, '?') for b in source if b != 0xff])

    def encode_to_bytes(self, value: str) -> bytes:
        if len(value) > 6:
            raise ValueError(f"Cannot encode value '{value}' for field {self.name}: max length = 6")
        return pad([CHARACTER_ENCODING.get(c, 0xBF) for c in value], size=6, padding_value=0xff)
